package cpcns.dingZhi.impAndexpUtil.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.impAndexpUtil.dao.ImpDao;
import cpcns.dingZhi.impAndexpUtil.service.ImpService;
import cpcns.utils.FtpConfig;
import cpcns.utils.FtpUtil;
import cpcns.utils.ImpAndOutUtils;
import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.formula.functions.T;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("impService")
public class ImpServiceImpl extends DangAnBaseServiceImpl<T> implements ImpService {
  @Autowired
  private ImpDao impDao;
  
  private Logger logger = LoggerFactory.getLogger(getClass());
  
  public String inportWenJian(String xmlFilePath, String saveFileDir, String quanZongHao, String table, String number) {
    String nums = "";
    try {
      Document document = ImpAndOutUtils.getDocument(xmlFilePath);
      Element root = document.getRootElement();
      List<?> rootList = root.elements();
      Integer sum = Integer.valueOf(0);
      Integer chongFu = Integer.valueOf(0);
      Integer zhixingNum = Integer.valueOf(0);
      Integer fjNum = Integer.valueOf(0);
      for (int i = 0; i < rootList.size(); i++) {
        Element wjs = (Element)rootList.get(i);
        if ("WENJIAN".equals(wjs.getName())) {
          sum = Integer.valueOf(sum.intValue() + 1);
          Integer newHbs = Integer.valueOf(0);
          Map<String, Object> wenJian = ImpAndOutUtils.getElementList(wjs.elements());
          if (wenJian != null) {
            String hql = "select HANGBIAOSHI from " + table + " where zhuangTai not in (3,4) and menLei = '" + wenJian.get("MENLEI") + "' and danghao='" + wenJian.get("DANGHAO") + "'";
            String hbs = this.impDao.gethangBiaoShiSql(hql);
            if (Integer.valueOf(hbs).intValue() <= 0 || !"0".equals(number)) {
              if (Integer.valueOf(hbs).intValue() > 0) {
                if ("1".equals(number)) {
                  this.impDao.deleteWenJian(wenJian, table);
                  try {
                    this.impDao.deleteWJFuJian(hbs, String.valueOf(table) + "FuJian", quanZongHao, saveFileDir);
                  } catch (IOException e) {
                    e.printStackTrace();
                  } 
                  newHbs = this.impDao.saveWenJian(wenJian, table, newHbs);
                } 
              } else if ("".equals(hbs) || hbs == null || "0".equals(hbs)) {
                zhixingNum = Integer.valueOf(zhixingNum.intValue() + 1);
                newHbs = this.impDao.saveWenJian(wenJian, table, newHbs);
              } 
              List<?> wjList = wjs.elements();
              for (int j = 0; j < wjList.size(); j++) {
                Element fjs = (Element)wjList.get(j);
                if ("WENJIANFUJIANS".equals(fjs.getName())) {
                  List<?> fjsList = fjs.elements();
                  for (int k = 0; k < fjsList.size(); k++) {
                    Element fj = (Element)fjsList.get(k);
                    if ("WENJIANFUJIAN".equals(fj.getName())) {
                      fjNum = Integer.valueOf(fjNum.intValue() + 1);
                      Map<String, Object> wenJianFuJian = ImpAndOutUtils.getElementList(fj.elements());
                      this.impDao.saveWenJian(wenJianFuJian, String.valueOf(table) + "FuJian", newHbs);
                      if ("1".equals(wenJianFuJian.get("CHANGQIBAOCUNBIAOSHI"))) {
                        if ("D_SHIWU".equals(table.toUpperCase()) || "D_YINXIANG".equals(table.toUpperCase())) {
                          if ("ZP".equals(wenJian.get("MENLEI")) || "SW".equals(wenJian.get("MENLEI")))
                            uploadFtp(quanZongHao, 
                                String.valueOf(wenJianFuJian.get("WENJIANCUNFANGLUJING").toString().replaceAll("·", "-")) + "thumb/", 
                                String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("WENJIANCUNFANGLUJING") + "thumb/" + wenJianFuJian.get("YUANWENJIANMINGCHENG"), 
                                wenJianFuJian.get("WENJIANMINGCHENG").toString().replaceAll("·", "-")); 
                          uploadFtp(quanZongHao, wenJianFuJian.get("WENJIANCUNFANGLUJING").toString().replaceAll("·", "-"), 
                              String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("WENJIANCUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMINGCHENG"), 
                              wenJianFuJian.get("WENJIANMINGCHENG").toString().replaceAll("·", "-"));
                        } else {
                          String fjlist = String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                          String fjlj = wenJianFuJian.get("CUNFANGLUJING").toString().replaceAll("·", "-");
                          String jsjwjm = wenJianFuJian.get("JISUANJIWENJIANMING").toString().replaceAll("·", "-");
                          uploadFtp(quanZongHao, fjlj, fjlist, jsjwjm);
                        } 
                      } else {
                        String fjlist = String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                        String fujianRootDir = AppConfiguration.getConfigValue("OACaiJiPath");
                        String newFJlist = String.valueOf(fujianRootDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                        File file = new File(fjlist);
                        if (file.exists()) {
                          try {
                            FileUtils.copyFile(new File(fjlist), new File(newFJlist), true);
                          } catch (IOException e) {
                            System.out.println("本地导入附件出错，附件的行标识为" + wenJianFuJian.get("HANGBIAOSHI"));
                            e.printStackTrace();
                          } 
                        } else {
                          System.out
                            .println("压缩包解压出错，对应文件" + fjlist + "不存在！");
                        } 
                      } 
                    } 
                  } 
                } 
              } 
            } 
          } else {
            System.out.println("文件为空！");
          } 
        } 
      } 
      nums = sum + "," + (sum.intValue() - zhixingNum.intValue()) + "," + zhixingNum + "," + fjNum;
    } catch (DocumentException e) {
      e.printStackTrace();
      System.out.println(e.getMessage());
    } 
    return nums;
  }
  
  public String inportAnJuan(String xmlFilePath, String saveFileDir, String quanZongHao, String table, String number) {
    String nums = "";
    try {
      Document document = ImpAndOutUtils.getDocument(xmlFilePath);
      Element root = document.getRootElement();
      List<?> rootList = root.elements();
      Integer sum = Integer.valueOf(0);
      Integer chongFu = Integer.valueOf(0);
      Integer zhixingNum = Integer.valueOf(0);
      Integer fjNum = Integer.valueOf(0);
      String wjtable = table.toLowerCase().replace("anjuan", "");
      if (StringUtils.isNoneBlank(new CharSequence[] { table }) && table.toUpperCase().equals("D_ZHUANYEANJUAN"))
        wjtable = table.replace("anjuan", "wenJian"); 
      for (int i = 0; i < rootList.size(); i++) {
        Element ajs = (Element)rootList.get(i);
        if ("ANJUAN".equals(ajs.getName())) {
          sum = Integer.valueOf(sum.intValue() + 1);
          Integer newHbs = Integer.valueOf(0);
          Map<String, Object> anJuan = ImpAndOutUtils.getElementList(ajs.elements());
          if (anJuan != null) {
            String hql = "select HANGBIAOSHI from " + table + " where zhuangTai not in (3,4) and danghao='" + anJuan.get("DANGHAO") + "'";
            String hbs = this.impDao.gethangBiaoShiSql(hql);
            if (Integer.valueOf(hbs).intValue() <= 0 || !"0".equals(number)) {
              if (Integer.valueOf(hbs).intValue() > 0 && "1".equals(number)) {
                this.impDao.deleteWenJian(anJuan, table);
                List<Map<String, Object>> wjs = this.impDao.queryWJ(hbs, wjtable);
                for (Map<String, Object> wj : wjs) {
                  this.impDao.deleteWenJian(wj, wjtable);
                  try {
                    this.impDao.deleteWJFuJian(wj.get("HANGBIAOSHI").toString(), String.valueOf(wjtable) + "FuJian", quanZongHao, saveFileDir);
                  } catch (IOException e) {
                    e.printStackTrace();
                  } 
                } 
                newHbs = this.impDao.saveAnjuan(anJuan, table, newHbs);
              } else if ("".equals(hbs) || hbs == null || "0".equals(hbs)) {
                zhixingNum = Integer.valueOf(zhixingNum.intValue() + 1);
                newHbs = this.impDao.saveAnjuan(anJuan, table, newHbs);
              } 
              List<?> wjList = ajs.elements();
              for (int j = 0; j < wjList.size(); j++) {
                Element wjs = (Element)wjList.get(j);
                if ("WENJIANS".equals(wjs.getName())) {
                  List<?> wjsList = wjs.elements();
                  for (int a = 0; a < wjsList.size(); a++) {
                    Element wj = (Element)wjsList.get(a);
                    if ("WENJIAN".equals(wj.getName())) {
                      Integer newfjHbs = Integer.valueOf(0);
                      Map<String, Object> wenJian = ImpAndOutUtils.getElementList(wj.elements());
                      newfjHbs = this.impDao.saveAnjuan(wenJian, wjtable, newHbs);
                      List<?> fjList = wj.elements();
                      for (int b = 0; b < fjList.size(); b++) {
                        Element fjs = (Element)fjList.get(b);
                        if ("WENJIANFUJIANS".equals(fjs.getName())) {
                          List<?> fjsList = fjs.elements();
                          for (int k = 0; k < fjsList.size(); k++) {
                            Element fj = (Element)fjsList.get(k);
                            if ("WENJIANFUJIAN".equals(fj.getName())) {
                              fjNum = Integer.valueOf(fjNum.intValue() + 1);
                              Map<String, Object> wenJianFuJian = ImpAndOutUtils.getElementList(fj.elements());
                              this.impDao.saveWenJian(wenJianFuJian, String.valueOf(wjtable) + "FuJian", newfjHbs);
                              if ("1".equals(wenJianFuJian.get("CHANGQIBAOCUNBIAOSHI"))) {
                                String fjlist = String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                                String fjlj = wenJianFuJian.get("CUNFANGLUJING").toString().replaceAll("·", "-");
                                String jsjwjm = wenJianFuJian.get("JISUANJIWENJIANMING").toString().replaceAll("·", "-");
                                uploadFtp(quanZongHao, fjlj, fjlist, jsjwjm);
                              } else {
                                String fjlist = String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                                String fujianRootDir = AppConfiguration.getConfigValue("OACaiJiPath");
                                String newFJlist = String.valueOf(fujianRootDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                                File file = new File(fjlist);
                                if (file.exists())
                                  try {
                                    FileUtils.copyFile(new File(fjlist), new File(newFJlist), true);
                                  } catch (IOException e) {
                                    System.out.println("本地导入附件出错，附件的行标识为" + wenJianFuJian.get("HANGBIAOSHI"));
                                    e.printStackTrace();
                                  }  
                              } 
                            } 
                          } 
                        } 
                      } 
                    } 
                  } 
                } 
              } 
            } 
          } else {
            System.out.println("文件为空！");
          } 
        } 
      } 
      nums = sum + "," + (sum.intValue() - zhixingNum.intValue()) + "," + zhixingNum + "," + fjNum;
    } catch (DocumentException e) {
      e.printStackTrace();
      System.out.println(e.getMessage());
    } 
    return nums;
  }
  
  public String inportXm(String xmlFileUrl, String saveFileDir, String quanZongHao, String table, String number) {
    String nums = "";
    try {
      Document document = ImpAndOutUtils.getDocument(xmlFileUrl);
      Element root = document.getRootElement();
      List<?> rootList = root.elements();
      Integer sum = Integer.valueOf(0);
      Integer chongFu = Integer.valueOf(0);
      Integer zhixingNum = Integer.valueOf(0);
      Integer fjNum = Integer.valueOf(0);
      for (int i = 0; i < rootList.size(); i++) {
        Element xms = (Element)rootList.get(i);
        if ("XIANGMU".equals(xms.getName())) {
          sum = Integer.valueOf(sum.intValue() + 1);
          String newGlbs = "";
          String hql = "";
          Map<String, Object> xiangmu = ImpAndOutUtils.getElementList(xms.elements());
          if (xiangmu != null) {
            if ("D_keJiXiangMu".equals(table)) {
              hql = "select HANGBIAOSHI from " + table + " where zhuangTai not in (3,4) and xiangMuhao ='" + xiangmu.get("XIANGMUHAO") + "'";
            } else {
              hql = "select HANGBIAOSHI from " + table + " where zhuangTai not in (3,4) and dangHao ='" + xiangmu.get("DANGHAO") + "'";
            } 
            String xmhbs = this.impDao.gethangBiaoShiSql(hql);
            if (Integer.valueOf(xmhbs).intValue() <= 0 || !"0".equals(number)) {
              if (Integer.valueOf(xmhbs).intValue() > 0 && "1".equals(number)) {
                if ("D_keJiXiangMu".equals(table)) {
                  this.impDao.deleteKJXiangMu(xiangmu, table);
                  List<Map<String, Object>> ajs = this.impDao.queryWJ(xmhbs, table.replace("XiangMu", "AnJuan"));
                  for (Map<String, Object> aj : ajs) {
                    this.impDao.deleteWenJian(aj, table.replace("XiangMu", "AnJuan"));
                    List<Map<String, Object>> wjs = this.impDao.queryWJ(aj.get("HANGBIAOSHI").toString(), table.replace("XiangMu", ""));
                    for (Map<String, Object> wj : wjs) {
                      this.impDao.deleteWenJian(wj, table.replace("XiangMu", ""));
                      try {
                        this.impDao.deleteWJFuJian(wj.get("HANGBIAOSHI").toString(), table.replace("XiangMu", "FuJian"), quanZongHao, saveFileDir);
                      } catch (Exception e) {
                        System.out.println(e.getMessage());
                      } 
                    } 
                  } 
                  newGlbs = this.impDao.saveXM(xiangmu, table, newGlbs);
                } else {
                  this.impDao.deleteWenJian(xiangmu, table);
                  List<Map<String, Object>> ajs = this.impDao.queryWJ(xmhbs, table.replace("XiangMu", "AnJuan"));
                  for (Map<String, Object> aj : ajs) {
                    this.impDao.deleteWenJian(aj, table.replace("XiangMu", "AnJuan"));
                    List<Map<String, Object>> wjs = this.impDao.queryWJ(aj.get("HANGBIAOSHI").toString(), table.replace("XiangMu", ""));
                    for (Map<String, Object> wj : wjs) {
                      this.impDao.deleteWenJian(wj, table.replace("XiangMu", ""));
                      try {
                        this.impDao.deleteWJFuJian(wj.get("HANGBIAOSHI").toString(), table.replace("XiangMu", "FuJian"), quanZongHao, saveFileDir);
                      } catch (Exception e) {
                        System.out.println(e.getMessage());
                      } 
                    } 
                  } 
                  newGlbs = this.impDao.saveXM(xiangmu, table, newGlbs);
                } 
              } else if ("".equals(xmhbs) || xmhbs == null || "0".equals(xmhbs)) {
                zhixingNum = Integer.valueOf(zhixingNum.intValue() + 1);
                newGlbs = this.impDao.saveXM(xiangmu, table, newGlbs);
              } 
              List<?> ajsList = xms.elements();
              for (int b = 0; b < ajsList.size(); b++) {
                Element ajs = (Element)ajsList.get(b);
                if ("ANJUANS".equals(ajs.getName())) {
                  List<?> ajlist = ajs.elements();
                  for (int f = 0; f < ajlist.size(); f++) {
                    Element aj = (Element)ajlist.get(f);
                    if ("ANJUAN".equals(aj.getName())) {
                      String newHbs = "";
                      Map<String, Object> anJuan = ImpAndOutUtils.getElementList(aj.elements());
                      if (anJuan != null) {
                        newHbs = this.impDao.saveXM(anJuan, table.replace("XiangMu", "AnJuan"), newGlbs);
                        List<?> wjList = aj.elements();
                        for (int j = 0; j < wjList.size(); j++) {
                          Element wjs = (Element)wjList.get(j);
                          if ("WENJIANS".equals(wjs.getName())) {
                            List<?> wjsList = wjs.elements();
                            for (int a = 0; a < wjsList.size(); a++) {
                              Element wj = (Element)wjsList.get(a);
                              if ("WENJIAN".equals(wj.getName())) {
                                Integer newfjHbs = Integer.valueOf(0);
                                Map<String, Object> wenJian = ImpAndOutUtils.getElementList(wj.elements());
                                newfjHbs = this.impDao.saveAnjuan(wenJian, table.replace("XiangMu", ""), Integer.valueOf(newHbs));
                                List<?> fjList = wj.elements();
                                for (int c = 0; c < fjList.size(); c++) {
                                  Element fjs = (Element)fjList.get(c);
                                  if ("WENJIANFUJIANS".equals(fjs.getName())) {
                                    List<?> fjsList = fjs.elements();
                                    for (int k = 0; k < fjsList.size(); k++) {
                                      Element fj = (Element)fjsList.get(k);
                                      if ("WENJIANFUJIAN".equals(fj.getName())) {
                                        fjNum = Integer.valueOf(fjNum.intValue() + 1);
                                        Map<String, Object> wenJianFuJian = ImpAndOutUtils.getElementList(fj.elements());
                                        this.impDao.saveWenJian(wenJianFuJian, table.replace("XiangMu", "FuJian"), newfjHbs);
                                        if ("1".equals(wenJianFuJian.get("CHANGQIBAOCUNBIAOSHI"))) {
                                          String fjlist = String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                                          String fjlj = wenJianFuJian.get("CUNFANGLUJING").toString().replaceAll("·", "-");
                                          String jsjwjm = wenJianFuJian.get("JISUANJIWENJIANMING").toString().replaceAll("·", "-");
                                          uploadFtp(quanZongHao, fjlj, fjlist, jsjwjm);
                                        } else {
                                          String fjlist = String.valueOf(saveFileDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                                          String fujianRootDir = AppConfiguration.getConfigValue("OACaiJiPath");
                                          String newFJlist = String.valueOf(fujianRootDir) + "/" + wenJianFuJian.get("CUNFANGLUJING") + wenJianFuJian.get("YUANWENJIANMING");
                                          File file = new File(fjlist);
                                          if (file.exists())
                                            try {
                                              FileUtils.copyFile(new File(fjlist), new File(newFJlist), true);
                                            } catch (IOException e) {
                                              System.out
                                                .println("本地导入附件出错，附件的行标识为" + wenJianFuJian.get("HANGBIAOSHI"));
                                              e.printStackTrace();
                                            }  
                                        } 
                                      } 
                                    } 
                                  } 
                                } 
                              } 
                            } 
                          } 
                        } 
                      } else {
                        System.out.println("文件为空！");
                      } 
                    } 
                  } 
                } 
              } 
            } 
          } 
        } 
      } 
      nums = sum + "," + (sum.intValue() - zhixingNum.intValue()) + "," + zhixingNum + "," + fjNum;
    } catch (DocumentException e) {
      e.printStackTrace();
      System.out.println(e.getMessage());
    } 
    return nums;
  }
  
  private boolean uploadFtp(String quanZongHao, String muLu, String oldFile, String newFileName) {
    boolean ftp = false;
    FtpUtil ftpUtil = null;
    try {
      FtpConfig config = this.impDao.getFtpAccInfo(quanZongHao);
      ftpUtil = new FtpUtil();
      ftpUtil.connectServer(config);
      boolean b = ftpUtil.createMultiDirectory(muLu);
      if (b) {
        File file = new File(oldFile);
        if (file.exists()) {
          String newFile = new String(newFileName.getBytes("UTF-8"), "iso-8859-1");
          ftp = ftpUtil.uploadFile(oldFile, newFile);
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      try {
        ftpUtil.closeServer();
      } catch (IOException e) {
        e.printStackTrace();
      } 
    } 
    return ftp;
  }
}
